using YBEE.EQM.Core;

namespace YBEE.EQM.Application;

/// <summary>
/// 高考划线计划管理服务
/// </summary>
public interface INceePlanService
{
    #region 创建更新
    /// <summary>
    /// 添加计划
    /// </summary>
    /// <param name="input"></param>
    /// <returns></returns>
    Task Add(AddNceePlanInput input);
    /// <summary>
    /// 更新计划
    /// </summary>
    /// <param name="input"></param>
    /// <returns></returns>
    Task Update(UpdateNceePlanInput input);
    /// <summary>
    /// 删除计划
    /// </summary>
    /// <param name="input"></param>
    /// <returns></returns>
    Task Del(BaseId input);
    #endregion

    #region 状态变更
    /// <summary>
    /// 开始监测
    /// </summary>
    /// <param name="input"></param>
    /// <returns></returns>
    Task Start(BaseId input);
    /// <summary>
    /// 结束监测
    /// </summary>
    /// <param name="input"></param>
    /// <returns></returns>
    Task Stop(BaseId input);
    /// <summary>
    /// 取消监测
    /// </summary>
    /// <param name="input"></param>
    /// <returns></returns>
    Task Cancel(BaseId input);
    #endregion

    #region 查询统计
    /// <summary>
    /// 根据ID获取计划
    /// </summary>
    /// <param name="id"></param>
    /// <returns></returns>
    Task<NceePlanOutput> GetById(int id);
    /// <summary>
    /// 分页查询计划列表
    /// </summary>
    /// <param name="input"></param>
    /// <returns></returns>
    Task<PageResult<NceePlanOutput>> QueryPageList(NceePlanPageInput input);
    /// <summary>
    /// 获取我的单据状态数量
    /// </summary>
    /// <returns></returns>
    Task<List<StatusCount>> QueryStatusCount(NceePlanPageInput input);
    #endregion
}
